# displayTree.py
#
import sarg, random, math
from button   import Button
from graphics import *
from sys      import maxsize

pixels  = sarg.Int("pixels", 600)

win = GraphWin("Binary Trees",pixels,pixels)
drawn   = []
buttons = []
entry = Entry(Point(300, 540), 2)

def drawStatic() :
    buttons.append(Button(Point(150,570), "Balance"))
    buttons.append(Button(Point(300,570), "Add/Del"))
    buttons.append(Button(Point(450,570), "Exit"))
    for but in buttons : but.draw(win)
    entry.draw(win)
    entry.setText("45")

def waitForButton() :
    pnt = win.getMouse()
    val = entry.getText()
    for but in buttons :
        if but.inside(pnt) :
            if but.text == "Add/Del": return val
            else                    : return but.text
    return waitForButton()     # keep trying

def drawTree(tree, pos, width, stepdown, ids=None) :
    for obj in drawn : obj.undraw()
    drawNode(tree, pos, width, stepdown, ids)

def displayOff() :
    win.close()

def drawText(color, x,y, text) :
    txt = Text(Point(x,y), str(text))
    txt.setFill(color)
    txt.draw(win)
    drawn.append(txt)

def drawLine(color, x,y, next_xy, width) :
    x2,y2 = next_xy
    p1 = Point(x,y); p2 = Point(x2,y2)
    line = Line(p1,p2)
    line.setFill(color)
    line.draw(win)
    drawn.append(line)

def drawNode(node, pos, width, stepdown, ids) :
    if node == None : return
    x,y = pos; value,left,right = node
    halfwidth = width/2
    nextR = (x+halfwidth,y+stepdown)
    if left :
        nextL = (x-halfwidth,y+stepdown)
        drawLine("white", x,y, nextL, width)
        drawNode(left , nextL, halfwidth, stepdown, ids)
    if right :
        nextR = (x+halfwidth,y+stepdown)
        drawLine("white", x,y, nextR, width)
        drawNode(right, nextR, halfwidth, stepdown, ids)
    if ids and id(node) in ids : color = "yellow"
    else                       : color = "red"
    drawText(color, x,y, str(value))
